<template>
  <section class="container">
    <AllBets></AllBets>
    <MyBets></MyBets>
    <PlayTable></PlayTable>
    <History></History>
    <Details></Details>
    <TheFooterModals></TheFooterModals>
    <Loader
      ref="loader"
      :timeToLoad="4000"
      :loadFunc="loadFunc">{{$t('common.sync')}}...
    </Loader>
    <PinCode @setLoader="setLoader"></PinCode>
    <TheActivatedDialog
      ref="activatedDialog"></TheActivatedDialog>
    <TheHelpDialog></TheHelpDialog>
  </section>
</template>

<script>
  import AllBets from '~/components/allBets/';
  import MyBets from '~/components/myBets/';
  import PlayTable from '~/components/playTable/';
  import History from '~/components/history/';
  import Loader from '~/components/UI/Loader';
  import PinCode from '~/components/PinCode/'
  import TheFooterModals from '~/components/common/footer/TheFooterModals';
  import Ws from '~/services/ws/';
  import Scatter from '~/services/wallet/scatter';
  import Cookies from 'js-cookie';
  import TheActivatedDialog from '~/components/deposit/TheActivatedDialog';
  import TheHelpDialog from '~/components/globalModals/helpPage/index';

  export default {
    name: 'Index',
    data() {
      return {}
    },
    components: {
      Loader,
      AllBets,
      MyBets,
      PlayTable,
      History,
      Details: () => import('~/components/history/History_details'),
      TheFooterModals,
      PinCode,
      TheActivatedDialog,
      TheHelpDialog
    },
    computed: {
      showPincode() {
        return this.$store.state.pincode.show;
      },
      gameEnabled() {
        return this.$store.state.game.globalGameSettings.game_enabled;
      },
      gameHash() {
        return this.$store.state.game.currentGame && this.$store.state.game.currentGame.house_seed_hash;
      }
    },
    methods: {
      loadFunc() {
        const canLoad = (Ws.activeSocket && Ws.activeSocket.state === 'open') && (!this.gameEnabled || this.gameHash) && Scatter.checked;
        if (canLoad) {
          this.$root.$refs['header_bottom'].canCheckWaiting = true;
          const {hash} = this.$route;
          if (hash === '#auth') {
            if (!this.$store.state.user.isAuth) {
              this.$root.$refs['headerTop'].showAuth();
            }
            history.pushState({}, null, window.location.pathname);
          }
          const showActivatedDialog = window.location.href.match(/\?status=[\w\d\-]*/gi);
          if (showActivatedDialog) {
            const status = showActivatedDialog[0].replace('?status=', '');
            if (status === 'success') {
              this.$refs['activatedDialog'].show();
              history.pushState({}, null, window.location.pathname);
            }
          }
        }

        return canLoad;
      },
      setLoader() {
        this.$refs['loader'].show();
        this.$store.dispatch('wallet/init');
      }
    },
    mounted() {
      if (!this.showPincode) {
        this.setLoader();
      }

      this.$root.$refs['loader'] = this.$refs['loader'];
      const ref = window.location.href.match(/\?ref=[\S]*/gi);
      const global_ref = window.location.href.match(/\?global_ref=[\S]*/gi);
      const ds_id = window.location.href.match(/\&ds_id=[\w\d\-]*/gi);
      if (ref && ref.length) {
        let r = ref[0].replace('?ref=', '');
        r = r.replace(/[#/]/gi, '');
        localStorage.setItem('referralOf', r);
      }
      if (global_ref && global_ref.length) {
        Cookies.set('global_referral', global_ref[0].replace('?global_ref=', ''))
      }
      if (ds_id && ds_id.length) {
        Cookies.set('ds_id', ds_id[0].replace('&ds_id=', ''))
      }
      if (ref && ref.length || global_ref && global_ref.length) {
        history.pushState({}, null, window.location.pathname);
      }
    }
  }
</script>
